	.686
	.model flat, stdcall
	option casemap :none
	
	include \masm32\include\ntdll.inc
	includelib \masm32\lib\ntdll.lib
	
	include \masm32\include\kernel32.inc
	includelib \masm32\lib\kernel32.lib

.code
comment '
 WRK:
	if (RequestedLimits.MinimumWorkingSetSize &&
       	RequestedLimits.MaximumWorkingSetSize) {
 		//
		// See if the caller just wants to purge the working set.
		// This is an unprivileged operation.
		//
		if (RequestedLimits.MinimumWorkingSetSize == (SIZE_T)-1 &&
			RequestedLimits.MaximumWorkingSetSize == (SIZE_T)-1) {
			PurgeRequest = TRUE;
			...
			'
EmptyWS proc
Local Ps:QUOTA_LIMITS
	invoke ZwQueryInformationProcess, NtCurrentProcess, ProcessQuotaLimits, addr Ps, sizeof(QUOTA_LIMITS), NULL
	.if !Eax
		or Ps.MinimumWorkingSetSize,-1
		or Ps.MaximumWorkingSetSize,-1
		invoke ZwSetInformationProcess, NtCurrentProcess, ProcessQuotaLimits, addr Ps, sizeof(QUOTA_LIMITS)
	.endif
	ret
EmptyWS endp

TestApiA proc Buffer:PVOID
	mov eax,Buffer
	mov ecx,D[eax]
	mov edx,D[eax]
	mov eax,D[eax]
	ret
TestApiA endp

TestApiB proc Buffer:PVOID
Local Ps:PROCESS_BASIC_INFORMATION
	invoke ZwQueryInformationProcess, NtCurrentProcess, ProcessBasicInformation, addr Ps, sizeof(PROCESS_BASIC_INFORMATION), Buffer
	; Buffer -> sizeof(PROCESS_BASIC_INFORMATION)
	ret
TestApiB endp

.data?
Sync		BOOLEAN ?
Base		PVOID ?
Ips		PVOID 32 DUP (?)

.code
Thread proc uses ebx Args:PVOID
	invoke GetTickCount
	lea ebx,[eax + 10000]	; 10s
	.repeat
		invoke TestApiB, Base
		invoke GetTickCount
	.until Eax > Ebx
	inc Sync
	ret
Thread endp

EP proc uses ebx esi edi
Local Ws[512]:PROCESS_WS_WATCH_INFORMATION		; 8k max.
Local S1ze:ULONG, TID:HANDLE

	invoke ZwSetInformationProcess, NtCurrentProcess, ProcessWorkingSetWatch, 0, 0

	mov Base,0
	mov S1ze,4
	invoke ZwAllocateVirtualMemory, NtCurrentProcess, addr Base, 0, addr S1ze, MEM_COMMIT, PAGE_READWRITE

	invoke CreateThread, 0, 0, addr Thread, 0, 0, addr TID

	xor esi,esi
	.repeat
		invoke ZwQueryInformationProcess, NtCurrentProcess, ProcessWorkingSetWatch, addr Ws, PAGE_SIZE, addr S1ze
		.if !Eax	; STATUS_NO_MORE_ENTRIES
			lea ebx,Ws
			assume ebx:PPROCESS_WS_WATCH_INFORMATION
			.repeat
				mov eax,[ebx].FaultingVa
				lea ecx,[eax - 4]
				.if (Base <= Eax) && (Base > Ecx)
					mov ecx,esi
					mov eax,[ebx].FaultingPc
					lea edi,Ips
					repne scasd
					.if !Zero?
						mov Ips[esi*4],eax
						inc esi
					.endif
				.endif
				add ebx,sizeof PROCESS_WS_WATCH_INFORMATION
			.until ![Ebx].FaultingPc
		.endif
		invoke EmptyWS
	.until Sync
	ret
EP endp
end EP