	.686
	.model flat, stdcall
	option casemap :none
	
	include \masm32\include\ntdll.inc
	includelib \masm32\lib\ntdll.lib
	
	include \masm32\include\kernel32.inc
	includelib \masm32\lib\kernel32.lib

.code
EOL	equ NULL
CRLF	equ <13, 10, EOL>

%DBG macro Msg$, ArgList:VARARG
Local S$
	pushfd
	pushad
	Args = 1
	For Arg, <ArgList>
		Args = Args + 1
		push Arg
	Endm
.data
	S$ CHAR Msg$, CRLF
.code
	push offset S$
	Call DbgPrint
	add esp,Args * 4
	popad
	popfd
endm

TestApi proc Buffer:PVOID
Local Ps:PROCESS_BASIC_INFORMATION
	invoke ZwQueryInformationProcess, NtCurrentProcess, ProcessBasicInformation, addr Ps, sizeof(PROCESS_BASIC_INFORMATION), Buffer
	ret
TestApi endp

EP proc uses ebx
Local Ws[512]:PROCESS_WS_WATCH_INFORMATION		; 8k max.
Local S1ze:ULONG
Local Base:PVOID

; Start WSW.

	invoke ZwSetInformationProcess, NtCurrentProcess, ProcessWorkingSetWatch, 0, 0

	mov Base,0
	mov S1ze,4
	invoke ZwAllocateVirtualMemory, NtCurrentProcess, addr Base, 0, addr S1ze, MEM_COMMIT, PAGE_READWRITE

; Reset WSW.

	invoke ZwQueryInformationProcess, NtCurrentProcess, ProcessWorkingSetWatch, addr Ws, PAGE_SIZE, addr S1ze

	invoke TestApi, Base

	invoke ZwQueryInformationProcess, NtCurrentProcess, ProcessWorkingSetWatch, addr Ws, PAGE_SIZE, addr S1ze
	.if !Eax
		lea ebx,Ws
		assume ebx:PPROCESS_WS_WATCH_INFORMATION
		.repeat
			mov eax,[ebx].FaultingVa
			lea ecx,[eax - 4]
			.if (Base <= Eax) && (Base > Ecx)
				%DBG "Ip: 0x%X", [Ebx].FaultingPc
				jmp @f
			.endif
			add ebx,sizeof PROCESS_WS_WATCH_INFORMATION
		.until ![Ebx].FaultingPc
		Int 3	; VM/DBG
	@@:
	.endif
	ret
EP endp
end EP